      SUBROUTINE lxlylz(p,rhobm,vx,vy,vz,
     .     phi,phiold,rhobmold,vold,nes,
     .     nx,ny,nz,gamma,at,ath,dat,dt,dtold,
     .     dmax,eta2,norm,dir)
!     

      IMPLICIT NONE

!     
!     parameters
!     

      INTEGER(1), DIMENSION (nx,ny,nz) :: nes
      REAL*8, DIMENSION (nx,ny,nz) :: phi,phiold
      REAL*8, DIMENSION (nx,ny,nz) :: p,vx,vy,vz,rhobm
      REAL*8, DIMENSION (nx,ny,nz) :: vold,rhobmold
      INTEGER:: nx,ny,nz
      REAL*8 :: at,dat,ath,dt,dtold
      REAL*8 :: eta2,gamma
      REAL*8 :: dmax,norm
      INTEGER:: dir


      SELECT CASE(dir)
      CASE (0)
         call lx(p,rhobm,vx,vy,vz,
     .        phi,phiold,rhobmold,vold,nes,
     .        nx,ny,nz,gamma,at,
     .        ath,dat,dt,dtold,
     .        dmax,eta2,norm)
         
      CASE (1)
         call ly(p,rhobm,vx,vy,vz,
     .        phi,phiold,rhobmold,vold,nes,
     .        nx,ny,nz,gamma,at,
     .        ath,dat,dt,dtold,
     .        dmax,eta2,norm)

      CASE (2)                        
         call lz(p,rhobm,vx,vy,vz,
     .        phi,phiold,rhobmold,vold,nes,
     .        nx,ny,nz,gamma,at,
     .        ath,dat,dt,dtold,
     .        dmax,eta2,norm)
         
      END SELECT
      


      END SUBROUTINE lxlylz
