	REAL*8 FUNCTION total(nnn,pres,rho,vx,vy,vz,rgamma1,ngrid)
!       
!       calculate internal energy density
!       
	IMPLICIT NONE

!       
!       parameters
!       
	

	INTEGER :: ngrid
	REAL*8, DIMENSION(ngrid) :: pres,rho,vx,vy,vz
	REAL*8 :: rgamma1


!       
!       local variables
!       
	
        INTEGER, INTENT(IN) :: nnn
!       
	total=pres(nnn)*rgamma1+0.5*rho(nnn)*(vx(nnn)*vx(nnn)+
     .       vy(nnn)*vy(nnn)+vz(nnn)*vz(nnn))
!       
	END FUNCTION total
