      SUBROUTINE start(ak,akq,nx)
!     

      IMPLICIT NONE

!     
!     parameters
!

      REAL*8, DIMENSION(0:nx-1) :: ak,akq
      REAL*8, PARAMETER :: pi=3.1415926, twopi=2.0*pi
      INTEGER :: nx
      REAL*8 :: xmax
!     
!     local variables
!
      real*8 dk
      INTEGER :: k
!     
      xmax = float(nx)
      dk=twopi/xmax
      do k=0,nx/2-1
         ak(k)=float(k)
      enddo
      do k=nx/2,nx-1
         ak(k)=float(k-nx)
      enddo
      do k=0,nx-1
         ak(k)=ak(k)*dk
         akq(k)=ak(k)*ak(k)
      enddo
      
      END SUBROUTINE start
!     


