 /* general pourpose "c" clock, by Michele Guidolin */


#include<time.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#define HAVE_GETTIMEOFDAY 1
#define HAVE_SYS_TIME_H 1 

#if defined(HAVE_GETTIMEOFDAY) && defined(HAVE_SYS_TIME_H)
 
#include<sys/time.h>

#elif defined(HAVE_SYS_TIMES_H)

#include<sys/times.h>

#else

#error not 'sys/time.h' neither 'sys/times.h'

#endif

double cclock_()
/* get the timer values  */
{
    double sec;

#ifndef HAVE_GETTIMEOFDAY 
    
    static struct tms tmp;
    times(&tmp);
    /* change below to get other information (e.g. tmp.tms_styme -> system time)*/
    sec = (double)(tmp.tms_utime) / (double)sysconf(_SC_CLK_TCK);

#else

    static struct timeval tmp;
    gettimeofday(&tmp, 0);
    sec = (double)tmp.tv_sec + tmp.tv_usec/1E6;

#endif

    return sec; 
} 



