      REAL*8 FUNCTION RK4(Y,DYDX,X,H,t0h0,omega_m,omega_v)
      IMPLICIT NONE
      
      real*8 :: t0h0
      real*8 :: omega_m,omega_v



      REAL*8  :: Y,DYDX,X,H
      REAL*8  :: HH,H6,XH
      REAL*8  :: YT,DYT,DYM
      REAL*8  :: DERIVS

      HH=H*0.5
      H6=H/6.
      XH=X+HH

      YT=Y+HH*DYDX
      DYT=DERIVS(YT,t0h0,omega_m,omega_v)
      YT=Y+HH*DYT
      DYM=DERIVS(YT,t0h0,omega_m,omega_v)
      YT=Y+H*DYM
      DYM=DYT+DYM
      DYT=DERIVS(YT,t0h0,omega_m,omega_v)
      RK4=Y+H6*(DYDX+DYT+2.*DYM)

      END FUNCTION RK4
